
#include <stdio.h>
#include "api.h"
#include "parameters.h"

#include "ffi_poly.h"
#include "nist-rng.h"
#include <sys/syscall.h>

long long cpucycles() {
  unsigned long long result;
  __asm__ volatile(".byte 15;.byte 49;shlq $32,%%rdx;orq %%rdx,%%rax" : "=a" (result) ::  "%rdx");
  return result;
}

int main() {

  /*  
  printf("\n");
  printf("*******************\n");
  printf("**** ROLLO-%d ****\n", PARAM_SECURITY);
  printf("*******************\n");

  printf("\n");
  printf("M: %d  |  ", PARAM_M);
  printf("N: %d  |  ", PARAM_N);
  printf("D: %d  |  ", PARAM_D);
  printf("R: %d  |  ", PARAM_R);
  printf("DFR: 2^-%d  |  ", PARAM_DFR);
  printf("Sec: %d bits", PARAM_SECURITY);
  printf("\n");
  */

  unsigned char pk[PUBLIC_KEY_BYTES];
  unsigned char sk[SECRET_KEY_BYTES];

  unsigned char ct[CIPHERTEXT_BYTES];
  unsigned char ss1[SHARED_SECRET_BYTES];
  unsigned char ss2[SHARED_SECRET_BYTES];
  
  unsigned char seed[48];
  syscall(SYS_getrandom, seed, 48, 0);
  randombytes_init(seed, NULL, 256);

  for(int i = 0 ; i < 100 ; i++) {
    crypto_kem_keypair(pk, sk);
    crypto_kem_enc(ct, ss1, pk);
    crypto_kem_dec(ss2, ct, sk);

    for(int j = 0 ; j < SHARED_SECRET_BYTES ; ++j) {
      if(ss1[j] != ss2[j]) {
        printf("Error after %d iterations\n", i);
        return 1;
      }
    }
  }

  return 0;
}

